# ngx-datatable

[![Join the chat at https://gitter.im/siemens/ngx-datatable](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/siemens/ngx-datatable?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Code Climate](https://codeclimate.com/github/siemens/ngx-datatable/badges/gpa.svg)](https://codeclimate.com/github/siemens/ngx-datatable)
[![Test Coverage](https://codeclimate.com/github/siemens/ngx-datatable/badges/coverage.svg)](https://codeclimate.com/github/siemens/ngx-datatable/coverage)
[![npm version](https://badge.fury.io/js/%40siemens%2Fngx-datatable.svg)](https://badge.fury.io/js/%40siemens%2Fngx-datatable)
[![npm downloads](https://img.shields.io/npm/dm/@siemens/ngx-datatable.svg)](https://npmjs.org/@siemens/ngx-datatable)

> **Note:** This project is a fork of [`swimlane/ngx-datatable`](https://github.com/swimlane/ngx-datatable)
> which we try to maintain further with bug-fixes and new features due to the
> large backlog of open pull-requests.

`ngx-datatable` is an Angular component for presenting large and complex data. It has all the features you would expect from any other table but in a light package with _no external dependencies_. The table was designed to be extremely flexible and light; it doesn't make any assumptions about your data or how you: filter, sort or page it.

It was built for modern browsers using _TypeScript, CSS3 and HTML5_ and Angular `8.0.0`. This is the sister project of the [angular-data-table](https://github.com/swimlane/angular-data-table) that is designed for Angular 1.x.

Check out the [documentation](https://siemens-com.gitbook.io/ngx-datatable/) & [demos](http://siemens.github.io/ngx-datatable/) for more information!

See the [changelog](https://github.com/siemens/ngx-datatable/blob/master/docs/changelog.md) for recent changes.

## Features

- Handle large data sets ( Virtual DOM )
- Expressive Header and Cell Templates
- Horizontal & Vertical Scrolling
- Column Reordering & Resizing
- Client/Server side Pagination & Sorting
- Intelligent Column Width Algorithms ( Force-fill & Flex-grow )
- Integrated Pager
- Cell & Row Selection ( Single, Multi, Keyboard, Checkbox )
- Fixed AND Fluid height
- Left and Right Column Pinning
- Row Detail View
- Decoupled theme'ing with included Google Material theme
- Light codebase / No external dependencies
- AoT Compilation Support
- Universal Support

## Installation

To use ngx-datatable in your project install it via [npm](https://www.npmjs.com/package/@siemens/ngx-datatable):

```
npm i @siemens/ngx-datatable --save
```

## Credits

`ngx-datatable` is a [Swimlane](http://swimlane.com) open-source project; we believe in giving back to the open-source community by sharing some of the projects we build for our application. Swimlane is an automated cyber security operations and incident response platform that enables cyber security teams to leverage threat intelligence, speed up incident response and automate security operations.

[SecOps Hub](http://secopshub.com) is an open, product-agnostic, online community for security professionals to share ideas, use cases, best practices, and incident response strategies.
